{
  "openapi": "3.0.1",
  "info": {
    "title": "CubeMaster API V2",
    "description": "RESTfull API for building a truck, trailer, pallet, ULD and box loading. You can explore API definitions without authorization. If you want to execute the APIs with Try it out, click on the Authorize button.",
    "license": {
      "name": "Try more samples in the Sand Box",
      "url": "https://www.cubemaster.net/Subscription/WebServices/Sandbox/main.asp"
    },
    "version": "v2"
  },
  "paths": {
    "/Loads": {
      "post": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Builds a new load and saves it in the loads database. A load with the same Title will be overwritten.",
        "operationId": "Building a load and managing the loads saved",
        "parameters": [
          {
            "name": "multiProcessed",
            "in": "query",
            "description": "Set true to build the load in multiple processes and get the result asynchronously. The result will be sent to your webhook listener that is specified in the webhookListenerURLToNewLoad.<BR>Set false to build the load in single process and get the results immediately,</BR>",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "cargoDetailLoadedFromDatabase",
            "in": "query",
            "description": "If true, the details of each cargo in the request body are loaded from the cargoes database that matches the cargo name. Otherwise, the data of each cargo should be included in the request body.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "containerDetailLoadedFromDatabase",
            "in": "query",
            "description": "If true, the details of each container in the request body is loaded from the containers database that match the container name. Otherwise, the data of each container should be included in the request body.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "loadSaved",
            "in": "query",
            "description": "If true, the load is saved to the database and allows a user to see it with Account to www.cubemaster.net. They are accessed on the Recently Saved under Home.",
            "schema": {
              "type": "boolean",
              "default": true
            }
          },
          {
            "name": "loadShared",
            "in": "query",
            "description": "If true, the load is shared when it was saved to the database. Once it is shared, all users in your company can see it. They are accessed on the Recently Shared under Home.",
            "schema": {
              "type": "boolean",
              "default": true
            }
          },
          {
            "name": "userId",
            "in": "query",
            "description": "Sets an email of a user who the load is saved under. If it is not set, the email of the credential consuming the API is used.",
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "webhookListenerURLToNewLoad",
            "in": "query",
            "description": "Sets a URL of the webhook listener to take the load which is sent from CubeMaster when the load is built asyncronosly.",
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "If true, the pictures of the filled containers are created and placed into the Graphics.images member of the FilledCotnainer in the response. If false, Graphics.images member of the FilledCotnainer would be NULL.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphics of the filled container will include the measurements on the pictures of the filled containers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on pictures generated if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the pictures of the spaces are created and placed into the Graphics.images member of each space of the FilledContainers in the response.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the pictures of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member of the FilledContainers is created. It includes the information of the steps to build a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the Placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "The unit of measure for the new load.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          },
          {
            "name": "reportLanguage",
            "in": "query",
            "description": "",
            "schema": {
              "$ref": "#/components/schemas/LanguageEnum"
            }
          },
          {
            "name": "reportToolbarShown",
            "in": "query",
            "description": "",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/Shipment"
              }
            },
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Shipment"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/Shipment"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/Shipment"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns the load built from the shipment.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Load"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "get": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Gets all loads saved in the loads database.",
        "operationId": "Building a load and managing the loads saved",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "Limits the number of loads selected.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 10
            }
          },
          {
            "name": "createdAt",
            "in": "query",
            "description": "Refers to the date of the creation of the load.",
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "shared",
            "in": "query",
            "description": "To retrieve only the shared loads, set the parameter to true. If you'd like to select both shared and non-shared loads, set it to false.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "When set to 'true', images of the filled containers are generated and stored within the 'Graphics.images' member of the 'FilledContainer' object in the response. When set to 'false', the 'Graphics.images' member of the 'FilledContainer' object will be null.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphic representation of the filled container will display measurements on the image.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on the images generated when graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the images associated with the spaces will be generated and stored within the Graphics.images member of each space within the FilledContainers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the images of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member within FilledContainers is generated. This Spaces member contains detailed information about the steps involved in constructing a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "Specifies the unit of measure used for the loads. If a load has a different UOM, it will be converted to the UOM specified in this parameter.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          },
          {
            "name": "reportLanguage",
            "in": "query",
            "description": "",
            "schema": {
              "$ref": "#/components/schemas/LanguageEnum"
            }
          },
          {
            "name": "reportToolbarShown",
            "in": "query",
            "description": "",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the loads found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/LoadDatabaseSearchResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Loads/{userId}": {
      "get": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Gets all loads saved in the loads database.",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "Limits the number of loads selected.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 10
            }
          },
          {
            "name": "createdAt",
            "in": "query",
            "description": "Refers to the date of the creation of the load.",
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "userId",
            "in": "path",
            "description": "Refers to the email address of the user who created the loads.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "shared",
            "in": "query",
            "description": "To retrieve only the shared loads, set the parameter to true. If you'd like to select both shared and non-shared loads, set it to false.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "When set to 'true', images of the filled containers are generated and stored within the 'Graphics.images' member of the 'FilledContainer' object in the response. When set to 'false', the 'Graphics.images' member of the 'FilledContainer' object will be null.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphic representation of the filled container will display measurements on the image.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on the images generated when graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the images associated with the spaces will be generated and stored within the Graphics.images member of each space within the FilledContainers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the images of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member within FilledContainers is generated. This Spaces member contains detailed information about the steps involved in constructing a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "Specifies the unit of measure used for the loads. If a load has a different UOM, it will be converted to the UOM specified in this parameter.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          },
          {
            "name": "reportLanguage",
            "in": "query",
            "description": "",
            "schema": {
              "$ref": "#/components/schemas/LanguageEnum"
            }
          },
          {
            "name": "reportToolbarShown",
            "in": "query",
            "description": "",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the loads found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/LoadDatabaseSearchResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Loads/{userId}/{title}": {
      "get": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Gets all loads saved in the loads database.",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "Limits the number of loads selected.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 10
            }
          },
          {
            "name": "createdAt",
            "in": "query",
            "description": "Refers to the date of the creation of the load.",
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "userId",
            "in": "path",
            "description": "Refers to the email address of the user who created the loads.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "title",
            "in": "path",
            "description": "Refers to the name given to a load created by a user. The search allows for partial matches. For example, if you put \"shipping\" to the title, it will select all loads with titles that contain the word \"shipping\".",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "shared",
            "in": "query",
            "description": "To retrieve only the shared loads, set the parameter to true. If you'd like to select both shared and non-shared loads, set it to false.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "When set to 'true', images of the filled containers are generated and stored within the 'Graphics.images' member of the 'FilledContainer' object in the response. When set to 'false', the 'Graphics.images' member of the 'FilledContainer' object will be null.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the images of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphic representation of the filled container will display measurements on the image.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on the images generated when graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the images associated with the spaces will be generated and stored within the Graphics.images member of each space within the FilledContainers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the images of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the images of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member within FilledContainers is generated. This Spaces member contains detailed information about the steps involved in constructing a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "Specifies the unit of measure used for the loads. If a load has a different UOM, it will be converted to the UOM specified in this parameter.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          },
          {
            "name": "reportLanguage",
            "in": "query",
            "description": "",
            "schema": {
              "$ref": "#/components/schemas/LanguageEnum"
            }
          },
          {
            "name": "reportToolbarShown",
            "in": "query",
            "description": "",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the loads found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/LoadDatabaseSearchResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "delete": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Deletes a load by title created by a user in the loads database.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who created the load.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "title",
            "in": "path",
            "description": "The title of load.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a DatabaseResponse.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Loads/{userId}/{title}/{filledContainerSeq}": {
      "get": {
        "tags": [
          "Building a load and managing the loads saved"
        ],
        "summary": "Gets a filled container in a load by title created by a user in the loads database.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who created the load.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "title",
            "in": "path",
            "description": "The title of load.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "filledContainerSeq",
            "in": "path",
            "description": "The sequence of the filled container in the load.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "If true, the pictures of the filled containers are created and placed into the Graphics.images member of the FilledCotnainer in the response. If false, Graphics.images member of the FilledCotnainer would be NULL.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphics of the filled container will include the measurements on the pictures of the filled containers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on pictures generated if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the pictures of the spaces are created and placed into the Graphics.images member of each space of the FilledContainers in the response.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the pictures of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member of the FilledContainers is created. It includes the information of the steps to build a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the Placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "The unit of measure for the new load.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          },
          {
            "name": "reportLanguage",
            "in": "query",
            "description": "",
            "schema": {
              "$ref": "#/components/schemas/LanguageEnum"
            }
          },
          {
            "name": "reportToolbarShown",
            "in": "query",
            "description": "",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a filled container found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/FilledContainer"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Cargoes/{name}": {
      "get": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Gets a cargo with name from the cargoes database.",
        "parameters": [
          {
            "name": "name",
            "in": "path",
            "description": "The name of cargo to be found.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the cargo found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no record found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "delete": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Deletes a cargo by name from the cargoes database.",
        "parameters": [
          {
            "name": "name",
            "in": "path",
            "description": "The name of cargo to be deleted. Required.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a DatabaseResponse.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Cargoes": {
      "get": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Gets cargoes from the cargoes database.",
        "operationId": "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)",
        "parameters": [
          {
            "name": "nameGroup",
            "in": "query",
            "description": "The name of group to be found. If not specified, all records are searched.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "nameCargo",
            "in": "query",
            "description": "The name of cargo in a group to be found. If not specified, all records are searched.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "aliasCargo",
            "in": "query",
            "description": "The alias of cargo in a group to be found. If not specified, all records are searched.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "alias2Cargo",
            "in": "query",
            "description": "The alias2 of cargo in a group to be found. If not specified, all records are searched.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the cargo found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CargoDatabaseSearchResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no record found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "post": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Inserts a cargo to the cargoes database. A cargo with the same Name is overwritten.",
        "operationId": "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)",
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns when the cargo was added.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Cargoes/Multiple": {
      "post": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Inserts multiples cargoes to the cargoes database.",
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "application/json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "text/json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "application/*+json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns when the cargoes were added.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "delete": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Deletes multiples cargoes by names from the cargoes database.",
        "requestBody": {
          "description": "An array of the names of cargoes to be deleted, like [\"value1\",\"value2\",\"value7\"].",
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              }
            },
            "application/json": {
              "schema": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              }
            },
            "text/json": {
              "schema": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              }
            },
            "application/*+json": {
              "schema": {
                "type": "array",
                "items": {
                  "type": "string"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns a DatabaseResponse.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Cargoes/{keyIs}": {
      "put": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Updates a cargo in the cargoes database. \r\nPartial update supported: It support partial updates, which will only update the fields you've provided in the request payload and leave the rest unchanged.",
        "parameters": [
          {
            "name": "keyIs",
            "in": "path",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/KeyColumnEnum"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/Cargo"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns when the cargo was updated.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Cargoes/Multiple/{keyIs}": {
      "put": {
        "tags": [
          "Managing the caroges master data (cargo is an item/product or SKU that are placed in a container)"
        ],
        "summary": "Updates multiple cargoes in the cargoes database. \r\nPartial update supported: It support partial updates, which will only update the fields you've provided in the request payload and leave the rest unchanged.",
        "parameters": [
          {
            "name": "keyIs",
            "in": "path",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/KeyColumnEnum"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "application/json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "text/json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            },
            "application/*+json": {
              "schema": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/Cargo"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns when the cargo was updated.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Containers/{type}": {
      "get": {
        "tags": [
          "Managing the containers master data such as Trailers, Trucks, Sea Containers, Pallets and Cartons"
        ],
        "summary": "Gets all containers from the containers database.",
        "parameters": [
          {
            "name": "type",
            "in": "path",
            "description": "The type of container. Required.",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ContainerTypeEnum"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the containers found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmptyContainerDatabaseSearchResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "post": {
        "tags": [
          "Managing the containers master data such as Trailers, Trucks, Sea Containers, Pallets and Cartons"
        ],
        "summary": "Inserts a container to the containers database.",
        "parameters": [
          {
            "name": "type",
            "in": "path",
            "description": "The type of container. Required.",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ContainerTypeEnum"
            }
          }
        ],
        "requestBody": {
          "description": "The definition of the container.",
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/EmptyContainer"
              }
            },
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EmptyContainer"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/EmptyContainer"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/EmptyContainer"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Returns when the container was added.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Database/Containers/{type}/{name}": {
      "get": {
        "tags": [
          "Managing the containers master data such as Trailers, Trucks, Sea Containers, Pallets and Cartons"
        ],
        "summary": "Gets a container with name from the containers database.",
        "parameters": [
          {
            "name": "type",
            "in": "path",
            "description": "The type of container. Required.",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ContainerTypeEnum"
            }
          },
          {
            "name": "name",
            "in": "path",
            "description": "The name of container to be found. Required.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the container found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmptyContainer"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no record found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "delete": {
        "tags": [
          "Managing the containers master data such as Trailers, Trucks, Sea Containers, Pallets and Cartons"
        ],
        "summary": "Deletes a container by name from the containers database.",
        "parameters": [
          {
            "name": "type",
            "in": "path",
            "description": "The type of container. Required.",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ContainerTypeEnum"
            }
          },
          {
            "name": "name",
            "in": "path",
            "description": "The name of container to be deleted. Required.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a DatabaseResponse.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Edit/Load/{userId}": {
      "post": {
        "tags": [
          "Managing the editing data"
        ],
        "summary": "Builds a load from the editing data such as the cargoes, containers and rules and saves it to the loads database.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who is editing the data. If it is not set, the email of the credential consuming the API is used.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns if the load was created.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          }
        }
      }
    },
    "/Edit/Build/{userId}": {
      "post": {
        "tags": [
          "Managing the editing data"
        ],
        "summary": "Builds a load from the editing data such as the cargoes, containers and rules and saves it to the loads database.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who is editing the data. If it is not set, the email of the credential consuming the API is used.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns if the load was created.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          }
        }
      }
    },
    "/Edit/{userId}": {
      "get": {
        "tags": [
          "Managing the editing data"
        ],
        "summary": "Gets the editing data such as the cargoes, containers and rules and the load built from them.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who is editing the data.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "If true, the pictures of the filled containers are created and placed into the Graphics.images member of the FilledCotnainer in the response. If false, Graphics.images member of the FilledCotnainer would be NULL.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphics of the filled container will include the measurements on the pictures of the filled containers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on pictures generated if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the pictures of the spaces are created and placed into the Graphics.images member of each space of the FilledContainers in the response.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the pictures of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member of the FilledContainers is created. It includes the information of the steps to build a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the Placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "The unit of measure for the new load.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns the live data found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Edit"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no record found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      },
      "delete": {
        "tags": [
          "Managing the editing data"
        ],
        "summary": "Deletes the editing data such as the cargoes, containers and rules.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who is editing the data.",
            "required": true,
            "schema": {
              "type": "string",
              "default": ""
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a DatabaseResponse.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DatabaseResponse"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Edit/GetShipment/{userId}/{filledContainerSeq}": {
      "get": {
        "tags": [
          "Managing the editing data"
        ],
        "summary": "Gets a filled container in a load by title created by a user in the loads database.",
        "parameters": [
          {
            "name": "userId",
            "in": "path",
            "description": "The id of user who created the load.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "filledContainerSeq",
            "in": "path",
            "description": "The sequence of the filled container in the load.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "graphicsCreated",
            "in": "query",
            "description": "If true, the pictures of the filled containers are created and placed into the Graphics.images member of the FilledCotnainer in the response. If false, Graphics.images member of the FilledCotnainer would be NULL.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the filled containers in the number of pixels. This value will be used only if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "graphicsShowScale",
            "in": "query",
            "description": "If true, the 3D graphics of the filled container will include the measurements on the pictures of the filled containers.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "graphicsBackgroundColorRGB",
            "in": "query",
            "description": "The RGB color to be painted on the background of the 3D graphics on pictures generated if graphicsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int64",
              "default": 0
            }
          },
          {
            "name": "thumbnailsCreated",
            "in": "query",
            "description": "If true, the pictures of the spaces are created and placed into the Graphics.images member of each space of the FilledContainers in the response.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "thumbnailsImageWidth",
            "in": "query",
            "description": "The width of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsImageDepth",
            "in": "query",
            "description": "The depth of the pictures of the spaces in the number of pixels. This value will be used only if thumbnailsCreated is true.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 200
            }
          },
          {
            "name": "thumbnailsCreatedInBlackWhite",
            "in": "query",
            "description": "If true, the pictures of the spaces are painted in color and black.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "spacesCreated",
            "in": "query",
            "description": "If true, the Spaces member of the FilledContainers is created. It includes the information of the steps to build a container.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "placementsCreated",
            "in": "query",
            "description": "If true, the Placements member of the spaces is created.",
            "schema": {
              "type": "boolean",
              "default": false
            }
          },
          {
            "name": "UOM",
            "in": "query",
            "description": "The unit of measure for the new load.",
            "schema": {
              "$ref": "#/components/schemas/UOMEnum"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Returns a filled container found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/FilledContainer"
                }
              }
            }
          },
          "400": {
            "description": "Returns when no records found or an error raised."
          },
          "401": {
            "description": "Returns when the login was failed."
          }
        }
      }
    },
    "/Upload/Shipment/Excel": {
      "post": {
        "tags": [
          "Shipment"
        ],
        "requestBody": {
          "content": {
            "multipart/form-data": {
              "schema": {
                "type": "object",
                "properties": {
                  "fileDetails": {
                    "type": "string",
                    "format": "binary"
                  }
                }
              },
              "encoding": {
                "fileDetails": {
                  "style": "form"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecordsProcessed"
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "AlgorithmTypeEnum": {
        "enum": [
          "Default",
          "MaxVolumeFirst",
          "Optimization",
          "Interlocked"
        ],
        "type": "string"
      },
      "BestfitContainersSelectionEnum": {
        "enum": [
          "BestfitDisabled",
          "BestfitMaxEmptySizeFirst",
          "BestfitMaxVolUtilFirst",
          "BestfitMaxLoadVolFirst",
          "BestfitMaxWeightUtilFirst"
        ],
        "type": "string"
      },
      "CalculationErrorEnum": {
        "enum": [
          "EmptyCargoList",
          "NoErrors",
          "LockeyNotFound",
          "UnableToSignin",
          "EmptyContainerList",
          "CargoIsTooSmall",
          "InvalidCargoOrientations",
          "InvalidCargoSize",
          "CargoHasZeroSetCount",
          "InvalidContainerSize",
          "CargoIsTooBig",
          "CargoHasZeroLoadCount",
          "CargoWidthLongerThanLength"
        ],
        "type": "string"
      },
      "CalculationTypeEnum": {
        "enum": [
          "MixLoad",
          "SetLoadByQuantity",
          "SetLoadByVolume",
          "UnitLoad",
          "MultipleSetLoadByQuantity"
        ],
        "type": "string"
      },
      "Cargo": {
        "type": "object",
        "properties": {
          "style": {
            "$ref": "#/components/schemas/StyleEnum"
          },
          "name": {
            "type": "string",
            "nullable": true
          },
          "description": {
            "type": "string",
            "nullable": true
          },
          "length": {
            "type": "number",
            "format": "double"
          },
          "width": {
            "type": "number",
            "format": "double"
          },
          "diameter": {
            "type": "number",
            "format": "double"
          },
          "height": {
            "type": "number",
            "format": "double"
          },
          "weight": {
            "type": "number",
            "format": "double"
          },
          "qty": {
            "type": "integer",
            "format": "int32"
          },
          "pieceInside": {
            "type": "integer",
            "format": "int32"
          },
          "orderPieces": {
            "type": "integer",
            "format": "int32"
          },
          "setRatio": {
            "type": "number",
            "format": "double"
          },
          "sequence": {
            "type": "integer",
            "format": "int32"
          },
          "price": {
            "type": "number",
            "format": "double"
          },
          "alias": {
            "type": "string",
            "nullable": true
          },
          "alias2": {
            "type": "string",
            "nullable": true
          },
          "groupName": {
            "type": "string",
            "nullable": true
          },
          "property1": {
            "type": "string",
            "nullable": true
          },
          "property2": {
            "type": "string",
            "nullable": true
          },
          "property3": {
            "type": "string",
            "nullable": true
          },
          "property4": {
            "type": "string",
            "nullable": true
          },
          "property5": {
            "type": "string",
            "nullable": true
          },
          "property6": {
            "type": "string",
            "nullable": true
          },
          "property7": {
            "type": "string",
            "nullable": true
          },
          "property8": {
            "type": "string",
            "nullable": true
          },
          "property9": {
            "type": "string",
            "nullable": true
          },
          "property10": {
            "type": "string",
            "nullable": true
          },
          "unitloadTopPattern": {
            "$ref": "#/components/schemas/UnitloadPatternEnum"
          },
          "unitloadBottomPattern": {
            "$ref": "#/components/schemas/UnitloadPatternEnum"
          },
          "unitloadLayersQtyRotated": {
            "type": "integer",
            "format": "int32"
          },
          "unitloadTopFlat": {
            "type": "boolean"
          },
          "overhangAllowed": {
            "type": "boolean"
          },
          "overhangLength": {
            "type": "number",
            "format": "double"
          },
          "overhangWidth": {
            "type": "number",
            "format": "double"
          },
          "orientationsAllowed": {
            "$ref": "#/components/schemas/OrientationEnum"
          },
          "isPalletized": {
            "type": "boolean"
          },
          "palletizing": {
            "$ref": "#/components/schemas/SingleCargoPalletizingRules"
          },
          "maxLayersOnOrientation1": {
            "type": "integer",
            "format": "int32"
          },
          "maxLayersOnOrientation2": {
            "type": "integer",
            "format": "int32"
          },
          "maxLayersOnOrientation3": {
            "type": "integer",
            "format": "int32"
          },
          "maxLayersOnOrientation4": {
            "type": "integer",
            "format": "int32"
          },
          "maxLayersOnOrientation5": {
            "type": "integer",
            "format": "int32"
          },
          "maxLayersOnOrientation6": {
            "type": "integer",
            "format": "int32"
          },
          "turnAllowedOnFloor": {
            "type": "boolean"
          },
          "orientationPriority": {
            "$ref": "#/components/schemas/OrientationPriorityRules"
          },
          "maxLayersAllowedOverDifferentCargoes": {
            "type": "boolean"
          },
          "stackValue": {
            "type": "integer",
            "format": "int32"
          },
          "stackCode": {
            "type": "string",
            "nullable": true
          },
          "maxSupportingWeight": {
            "type": "number",
            "format": "double"
          },
          "floorStackType": {
            "$ref": "#/components/schemas/FloorStackEnum"
          },
          "floorStackSupportsOthers": {
            "type": "boolean"
          },
          "color": {
            "type": "integer",
            "format": "int64"
          },
          "colorHexaCode": {
            "type": "string",
            "nullable": true
          },
          "colorKnownName": {
            "type": "string",
            "nullable": true
          },
          "isOptional": {
            "type": "boolean"
          },
          "unitload": {
            "$ref": "#/components/schemas/FilledContainer"
          },
          "palletizedUnitloadsQty": {
            "type": "integer",
            "format": "int32"
          },
          "bulgeSize": {
            "$ref": "#/components/schemas/Size"
          },
          "emptyContainersFavorite": {
            "type": "array",
            "items": {
              "type": "string"
            },
            "nullable": true
          },
          "faceOpen": {
            "$ref": "#/components/schemas/FaceOpenEnum"
          },
          "departureTime": {
            "type": "string",
            "nullable": true
          },
          "sharingCode": {
            "type": "string",
            "nullable": true
          }
        },
        "additionalProperties": false
      },
      "CargoDatabaseSearchResponse": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "count": {
            "type": "integer",
            "format": "int32"
          },
          "items": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Cargo"
            },
            "nullable": true,
            "readOnly": true
          }
        },
        "additionalProperties": false
      },
      "CargoesDataSource": {
        "type": "object",
        "properties": {
          "from": {
            "$ref": "#/components/schemas/CargoesSourceEnum"
          },
          "favoriteName": {
            "type": "string",
            "nullable": true
          },
          "palletloadsShipment": {
            "$ref": "#/components/schemas/Shipment"
          }
        },
        "additionalProperties": false
      },
      "CargoesSourceEnum": {
        "enum": [
          "FavoriteDatabase",
          "MasterDatabase",
          "DefaultDatabase",
          "PalletloadsShipment",
          "LoadSaved"
        ],
        "type": "string"
      },
      "CargoGroup": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "nullable": true
          },
          "description": {
            "type": "string",
            "nullable": true
          },
          "sequence": {
            "type": "integer",
            "format": "int32"
          },
          "mixPallet": {
            "$ref": "#/components/schemas/EmptyContainer"
          },
          "floorStackType": {
            "$ref": "#/components/schemas/FloorStackEnum"
          },
          "floorStackSupportsOthers": {
            "type": "boolean"
          },
          "color": {
            "type": "integer",
            "format": "int64"
          },
          "maxVolumePerContainer": {
            "type": "number",
            "format": "double"
          },
          "maxWeightPerContainer": {
            "type": "number",
            "format": "double"
          },
          "palletNameFavorite": {
            "type": "string",
            "nullable": true
          },
          "truckNameFavorite": {
            "type": "string",
            "nullable": true
          },
          "seaContainerNameFavorite": {
            "type": "string",
            "nullable": true
          },
          "cartonNameFavorite": {
            "type": "string",
            "nullable": true
          },
          "uldNameFavorite": {
            "type": "string",
            "nullable": true
          },
          "isMixedWithOthers": {
            "type": "boolean"
          }
        },
        "additionalProperties": false
      },
      "CargoGroupInFilledContainer": {
        "type": "object",
        "properties": {
          "groupName": {
            "type": "string",
            "nullable": true
          },
          "sequence": {
            "type": "integer",
            "format": "int32"
          },
          "cargoQty": {
            "type": "integer",
            "format": "int64"
          },
          "bytesImage3D": {
            "type": "string",
            "nullable": true
          }
        },
        "additionalProperties": false
      },
      "CartonTypeEnum": {
        "enum": [
          "Tuck",
          "TuckWithoutMinorFlap",
          "RSC",
          "RSCClosed",
          "HSC",
          "Cube",
          "TrayHalf",
          "ShrinkWrap",
          "BottomOpen"
        ],
        "type": "string"
      },
      "Contact": {
        "type": "object",
        "properties": {
          "portName": {
            "type": "string",
            "nullable": true
          },
          "portGate": {
            "type": "string",
            "nullable": true
          },
          "portTerminal": {
            "type": "string",
            "nullable": true
          },
          "portCode": {
            "type": "string",
            "nullable": true
          },
          "streetAddress": {
            "type": "string",
            "nullable": true
          },
          "country": {
            "type": "string",
            "nullable": true
          },
          "city": {
            "type": "string",
            "nullable": true
          },
          "postalCode": {
            "type": "string",
            "nullable": true
          },
          "personName": {
            "type": "string",
            "nullable": true
          },
          "phone": {
            "type": "string",
            "nullable": true
          },
          "eMail": {
            "type": "string",
            "nullable": true
          },
          "vatID": {
            "type": "string",
            "nullable": true
          },
          "companyName": {
            "type": "string",
            "nullable": true
          },
          "geoLocation": {
            "type": "string",
            "nullable": true
          }
        },
        "additionalProperties": false
      },
      "ContainerGraphics": {
        "type": "object",
        "properties": {
          "images": {
            "$ref": "#/components/schemas/ContainerImagePaths"
          }
        },
        "additionalProperties": false
      },
      "ContainerImagePaths": {
        "type": "object",
        "properties": {
          "path3DDiagram": {
            "type": "string",
            "nullable": true
          },
          "path2DBottom": {
            "type": "string",
            "nullable": true
          },
          "path2DTop": {
            "type": "string",
            "nullable": true
          },
          "path2DLeft": {
            "type": "string",
            "nullable": true
          },
          "path2DRight": {
            "type": "string",
            "nullable": true
          },
          "path2DRear": {
            "type": "string",
            "nullable": true
          },
          "path2DFront": {
            "type": "string",
            "nullable": true
          },
          "pathComposite": {
            "type": "string",
            "nullable": true
          },
          "path3DDiagramMeasured": {
            "type": "string",
            "nullable": true,
            "readOnly": true
          },
          "path3DDiagramWeight": {
            "type": "string",
            "nullable": true,
            "readOnly": true
          }
        },
        "additionalProperties": false
      },
      "ContainerLoadSummary": {
        "type": "object",
        "properties": {
          "cargoesLoaded": {
            "type": "number",
            "format": "double"
          },
          "piecesLoaded": {
            "type": "number",
            "format": "double"
          },
          "unitloadsLoaded": {
            "type": "number",
            "format": "double"
          },
          "volumeLoaded": {
            "type": "number",
            "format": "double"
          },
          "volumeUtilization": {
            "type": "number",
            "format": "double"
          },
          "vollumeUtilizationToLoadHeight": {
            "type": "number",
            "format": "double"
          },
          "floorLoaded": {
            "type": "number",
            "format": "double"
          },
          "floorUtilization": {
            "type": "number",
            "format": "double"
          },
          "weightLoaded": {
            "type": "number",
            "format": "double"
          },
          "weightTotal": {
            "type": "number",
            "format": "double"
          },
          "weightUtilization": {
            "type": "number",
            "format": "double"
          },
          "dimWeight": {
            "type": "number",
            "format": "double"
          },
          "priceLoaded": {
            "type": "number",
            "format": "double"
          },
          "pricetUtilization": {
            "type": "number",
            "format": "double"
          },
          "cargoesPerLayer": {
            "type": "integer",
            "format": "int64"
          },
          "layersPerUnitload": {
            "type": "integer",
            "format": "int64"
          }
        },
        "additionalProperties": false
      },
      "ContainerReportsLinks": {
        "type": "object",
        "properties": {
          "overview": {
            "type": "string",
            "nullable": true
          }
        },
        "additionalProperties": false
      },
      "ContainersDataSource": {
        "type": "object",
        "properties": {
          "from": {
            "$ref": "#/components/schemas/ContainersSourceEnum"
          },
          "favoriteName": {
            "type": "string",
            "nullable": true
          },
          "type": {
            "$ref": "#/components/schemas/ContainerTypeEnum"
          }
        },
        "additionalProperties": false
      },
      "ContainersSourceEnum": {
        "enum": [
          "FavoriteDatabase",
          "MasterDatabase",
          "DefaultDatabase"
        ],
        "type": "string"
      },
      "ContainerTypeEnum": {
        "enum": [
          "Carton",
          "Pallet",
          "SeaVan",
          "Truck",
          "AirPallet",
          "Can",
          "Bottle"
        ],
        "type": "string"
      },
      "DatabaseResponse": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "count": {
            "type": "integer",
            "format": "int32"
          }
        },
        "additionalProperties": false
      },
      "DataSources": {
        "type": "object",
        "properties": {
          "containers": {
            "$ref": "#/components/schemas/ContainersDataSource"
          },
          "cargoes": {
            "$ref": "#/components/schemas/CargoesDataSource"
          }
        },
        "additionalProperties": false
      },
      "Edit": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "count": {
            "type": "integer",
            "format": "int32"
          },
          "shipment": {
            "$ref": "#/components/schemas/Shipment"
          },
          "load": {
            "$ref": "#/components/schemas/Load"
          }
        },
        "additionalProperties": false
      },
      "EmptyContainer": {
        "type": "object",
        "properties": {
          "containerType": {
            "$ref": "#/components/schemas/ContainerTypeEnum"
          },
          "vehicleType": {
            "$ref": "#/components/schemas/VehicleTypeEnum"
          },
          "palletType": {
            "$ref": "#/components/schemas/PalletTypeEnum"
          },
          "cartonType": {
            "$ref": "#/components/schemas/CartonTypeEnum"
          },
          "qty": {
            "type": "integer",
            "format": "int64"
          },
          "length": {
            "type": "number",
            "format": "double"
          },
          "width": {
            "type": "number",
            "format": "double"
          },
          "height": {
            "type": "number",
            "format": "double"
          },
          "emptyWeight": {
            "type": "number",
            "format": "double"
          },
          "maxLength": {
            "type": "number",
            "format": "double"
          },
          "maxWidth": {
            "type": "number",
            "format": "double"
          },
          "maxHeight": {
            "type": "number",
            "format": "double"
          },
          "maxWeight": {
            "type": "number",
            "format": "double"
          },
          "palletThickness": {
            "type": "number",
            "format": "double"
          },
          "maxVolPercent": {
            "type": "number",
            "format": "double"
          },
          "name": {
            "type": "string",
            "nullable": true
          },
          "description": {
            "type": "string",
            "nullable": true
          },
          "priority": {
            "type": "integer",
            "format": "int32"
          },
          "maxCargoTypes": {
            "type": "integer",
            "format": "int32"
          },
          "color": {
            "type": "number",
            "format": "double"
          },
          "colorHexaCode": {
            "type": "string",
            "nullable": true
          },
          "colorKnownName": {
            "type": "string",
            "nullable": true
          },
          "palletOverhang": {
            "type": "boolean"
          },
          "palletOverhangLength": {
            "type": "number",
            "format": "double"
          },
          "palletOverhangWidth": {
            "type": "number",
            "format": "double"
          },
          "palletUnderhang": {
            "type": "boolean"
          },
          "palletUnderhangLength": {
            "type": "number",
            "format": "double"
          },
          "palletUnderhangWidth": {
            "type": "number",
            "format": "double"
          },
          "price": {
            "type": "number",
            "format": "double"
          },
          "maxPrice": {
            "type": "number",
            "format": "double"
          },
          "zones": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Zone"
            },
            "nullable": true
          },
          "vehicleDropDeckRearSize": {
            "$ref": "#/components/schemas/Size"
          },
          "vehicleDropDeckFrontSize": {
            "$ref": "#/components/schemas/Size"
          }
        },
        "additionalProperties": false
      },
      "EmptyContainerDatabaseSearchResponse": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "count": {
            "type": "integer",
            "format": "int32"
          },
          "items": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/EmptyContainer"
            },
            "nullable": true,
            "readOnly": true
          }
        },
        "additionalProperties": false
      },
      "FaceOpenEnum": {
        "enum": [
          "NeitherSide",
          "LengthSide",
          "WidthSide"
        ],
        "type": "string"
      },
      "FillDirectionEnum": {
        "enum": [
          "FrontToRear",
          "BottomToTop"
        ],
        "type": "string"
      },
      "FilledContainer": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "nullable": true
          },
          "sequence": {
            "type": "integer",
            "format": "int32"
          },
          "loadSummary": {
            "$ref": "#/components/schemas/ContainerLoadSummary"
          },
          "actualSize": {
            "$ref": "#/components/schemas/Size"
          },
          "loadSize": {
            "$ref": "#/components/schemas/Size"
          },
          "cog": {
            "$ref": "#/components/schemas/Size"
          },
          "emptyContainer": {
            "$ref": "#/components/schemas/EmptyContainer"
          },
          "graphics": {
            "$ref": "#/components/schemas/ContainerGraphics"
          },
          "spaces": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SpaceInContainer"
            },
            "nullable": true
          },
          "manifest": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ManifestLine"
            },
            "nullable": true
          },
          "cargoGroups": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/CargoGroupInFilledContainer"
            },
            "nullable": true
          },
          "reportLinks": {
            "$ref": "#/components/schemas/ContainerReportsLinks"
          },
          "uom": {
            "$ref": "#/components/schemas/UOMEnum"
          }
        },
        "additionalProperties": false
      },
      "FloorStackEnum": {
        "enum": [
          "BestFit",
          "BottomOnly",
          "NoBottom"
        ],
        "type": "string"
      },
      "GroupsStackingRuleEnum": {
        "enum": [
          "BestFit",
          "AlwaysNotAllowed"
        ],
        "type": "string"
      },
      "KeyColumnEnum": {
        "enum": [
          "Name",
          "Alias1",
          "Alias2"
        ],
        "type": "string"
      },
      "LanguageEnum": {
        "enum": [
          "ENG",
          "GER",
          "SPN",
          "FRN",
          "BRZ",
          "CHN",
          "JPN",
          "KOR"
        ],
        "type": "string"
      },
      "Load": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "calculationError": {
            "$ref": "#/components/schemas/CalculationErrorEnum"
          },
          "document": {
            "$ref": "#/components/schemas/LoadDocument"
          },
          "loadSummary": {
            "$ref": "#/components/schemas/ShipmentLoadSummary"
          },
          "filledContainers": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/FilledContainer"
            },
            "nullable": true
          },
          "reportLinks": {
            "$ref": "#/components/schemas/LoadReportsLinks"
          },
          "shipping": {
            "$ref": "#/components/schemas/Shipping"
          }
        },
        "additionalProperties": false
      },
      "LoadDatabaseSearchResponse": {
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/StatusEnum"
          },
          "message": {
            "type": "string",
            "nullable": true
          },
          "count": {
            "type": "integer",
            "format": "int32"
          },
          "items": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Load"
            },
            "nullable": true,
            "readOnly": true
          }
        },
        "additionalProperties": false
      },
      "LoadDocument": {
        "type": "object",
        "properties": {
          "title": {
            "type": "string",
            "nullable": true
          },
          "description": {
            "type": "string",
            "nullable": true
          },
          "isShared": {
            "type": "boolean"
          },
          "isAutoSaved": {
            "type": "boolean"
          },
          "isPending": {
            "type": "boolean"
          },
          "calculationTimeInSeconds": {
            "type": "number",
            "format": "double"
          },
          "processId": {
            "type": "string",
            "nullable": true
          },
          "batchId": {
            "type": "string",
            "nullable": true
          },
          "createdBy": {
            "type": "string",
            "nullable": true
          },
          "createdAt": {
            "type": "string",
            "format": "date-time"
          },
          "updatedAt": {
            "type": "string",
            "format": "date-time"
          },
          "containerType": {
            "$ref": "#/components/schemas/ContainerTypeEnum"
          },
          "calculationType": {
            "$ref": "#/components/schemas/CalculationTypeEnum"
          }
        },
        "additionalProperties": false
      },
      "LoadReports": {
        "type": "object",
        "properties": {
          "loadSummary": {
            "type": "string",
[...]
